"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ProductMap_1 = require("../ProductMap");
class BinanceAPI {
    static product(genericProduct) {
        return ProductMap_1.ProductMap.ExchangeMap.get('Binance').getExchangeProduct(genericProduct) || genericProduct;
    }
    static genericProduct(exchangeProduct) {
        return ProductMap_1.ProductMap.ExchangeMap.get('Binance').getGenericProduct(exchangeProduct) || exchangeProduct;
    }
    static getMarket(genericProduct) {
        return ProductMap_1.ProductMap.ExchangeMap.get('Binance').getMarket(genericProduct);
    }
    static getMarketForExchangeProduct(exchangeProduct) {
        return ProductMap_1.ProductMap.ExchangeMap.get('Binance').getMarket(BinanceAPI.genericProduct(exchangeProduct));
    }
    constructor(auth, logger) {
        this.owner = 'Binance';
        this.logger = logger;
    }
    loadProducts() {
        throw ('loadProducts Not Implemented for Binance');
    }
    loadMidMarketPrice(genericProduct) {
        throw ('loadMidMarketPrice Not Implemented for Binance');
    }
    loadOrderbook(genericProduct) {
        throw ('loadMidMarketPrice Not Implemented for Binance');
        // const product = BinanceAPI.product(genericProduct);
        // return new Promise((resolve, reject) => {
        //     Binance.getorderbook({
        //         market: product,
        //         type: 'both',
        //         depth: 5000
        //     }, (err, data) => {
        //         if (err) {
        //             return reject(err);
        //         }
        //         if (!data.success || !data.result) {
        //             return reject(new Error('Unexpected response from Binance: ' + JSON.stringify(data)));
        //         }
        //         const bids: any = data.result.buy;
        //         const asks: any = data.result.sell;
        //         const book: BookBuilder = new BookBuilder(this.logger);
        //         bids.forEach((order: any) => {
        //             book.add({
        //                 id: order.Rate,
        //                 price: Big(order.Rate),
        //                 size: Big(order.Quantity),
        //                 side: 'buy'
        //             });
        //         });
        //         asks.forEach((order: any) => {
        //             book.add({
        //                 id: order.Rate,
        //                 price: Big(order.Rate),
        //                 size: Big(order.Quantity),
        //                 side: 'sell'
        //             });
        //         });
        //         return resolve(book);
        //     });
        // });
    }
    loadTicker(genericProduct) {
        throw ('Not Implemented');
    }
    placeOrder(order) {
        throw new Error('Method not implemented.');
    }
    cancelOrder(id) {
        throw new Error('Method not implemented.');
    }
    cancelAllOrders(product) {
        throw new Error('Method not implemented.');
    }
    loadOrder(id) {
        throw new Error('Method not implemented.');
    }
    loadAllOrders(genericProduct) {
        throw new Error('Method not implemented.');
    }
    loadBalances() {
        throw new Error('Method not implemented.');
    }
}
exports.BinanceAPI = BinanceAPI;
