"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ProductMap_1 = require("../src/exchanges/ProductMap");
let fetchingInprogress = false;
let fetchingPromise;
function prepareProductMap() {
    return __awaiter(this, void 0, void 0, function* () {
        if (ProductMap_1.ProductMap.ExchangeMap.size < 4 && (!fetchingInprogress)) {
            fetchingInprogress = true;
            let gdaxPromise = ProductMap_1.ProductMap.configureExchange('GDAX');
            let bitfinexPromise = ProductMap_1.ProductMap.configureExchange('Bitfinex');
            let bittrexPromise = ProductMap_1.ProductMap.configureExchange('Bittrex');
            let poloniexPromise = ProductMap_1.ProductMap.configureExchange('Poloniex');
            fetchingPromise = Promise.all([gdaxPromise, bitfinexPromise, bittrexPromise, poloniexPromise]);
            return fetchingPromise;
        }
        else if (fetchingInprogress) {
            return fetchingPromise;
        }
        else {
            return Promise.resolve(true);
        }
    });
}
exports.prepareProductMap = prepareProductMap;
prepareProductMap();
